当前位置:首页 > 开发 > 编程语言 > 编程 > 正文

Junit测试的抛出异常基础实例

发表于: 2013-10-09   作者:alleni123   来源:转载   浏览:
摘要: public class Calculator { public int divide(int a, int b) throws Exception{ if(0==b){ throw new Exception("除数不能为0"); } return a/b; } } 这里我们在CalculatorTest里面要测试
public class Calculator
{	
   	public int divide(int a, int b) throws Exception{
		if(0==b){
			throw new Exception("除数不能为0");
		}
		 
		return a/b;
	}
}


这里我们在CalculatorTest里面要测试这个异常的抛出。

        @Test
	public void testDivideByZero(){
		 
	 	  Throwable th=null;
			try
			{
				cal.divide(4, 0);
				fail();
			}
			catch (Exception e)
			{	
				th=e;
				e.printStackTrace();
				 
			
			}
	 
		
		
	 	assertEquals(Exception.class, th.getClass()); 
	 	assertEquals("除数不能为0", th.getMessage());
	 	
		 
	}


在这里声明一个Throwable类的对象th, 由于Throwable是Exception的父类,所以在catch语句中, 我们可以将th指向e的引用。
最后测试Exception.class和th.getClass()是否是同一个运行中的类,
然后测试message是否相同。

这个是junit3的测试方法。 junit4就特别简单了。
通过注释的方法
@Test(expected=Exception.class)
然后去掉try/catch那一堆, 就可以了。

Junit测试的抛出异常基础实例

  • 0

    开心

    开心

  • 0

    板砖

    板砖

  • 0

    感动

    感动

  • 0

    有用

    有用

  • 0

    疑问

    疑问

  • 0

    难过

    难过

  • 0

    无聊

    无聊

  • 0

    震惊

    震惊

版权所有 IT知识库 CopyRight © 2009-2015 IT知识库 IT610.com , All Rights Reserved. 京ICP备09083238号